//graphics.h
#ifndef _GRAPHICS_H
#define _GRAPHICS_H


#include <d3d9.h>
#include <d3dx9.h>


//UXUT.h  
#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { if (p) { delete (p);     (p)=NULL; } }
#endif    
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if (p) { delete[] (p);   (p)=NULL; } }
#endif    
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p)      { if (p) { (p)->Release(); (p)=NULL; } }
#endif


class CGraphics
{
public:
	CGraphics();
	virtual ~CGraphics();

public:
	bool Create(HWND hWnd, int iWidth,int iHeight, bool bIsFullScreen);
	HRESULT RestoreDevice();
	IDirect3DDevice9 * GetDevice();
	void	Cleanup();

public:
	virtual HRESULT CreateDevice(bool bIsFullScreen);
	virtual void	SetupCamera();
	virtual void	BeginScene();
	virtual HRESULT EndScene();
	

protected:
	IDirect3D9 *			m_pD3D;
	IDirect3DDevice9 *		m_pDevice;
	D3DPRESENT_PARAMETERS	m_d3dpp;

	//̽ ҽǽ ϱ 
	D3DDISPLAYMODE			m_dmMode;

	int		m_iWidth;
	int		m_iHeight;
	HWND	m_hWnd;
};


#endif